SystemOrganization addCategory: #'Magritte-XMLSupport'!
SystemOrganization addCategory: #'Magritte-XMLSupport-Tests'!

SAXHandler subclass: #MAXMLParser
	instanceVariableNames: 'stack idDictionary result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLParser class methodsFor: 'parsing' stamp: 'jvds 1/30/2010 17:05'!
parse: aStream

	^(self parseDocumentFrom: aStream) result! !

!MAXMLParser methodsFor: 'content' stamp: 'jvds 1/30/2010 16:24'!
characters: aString
	"This call corresponds to the Java SAX call
	characters(char[] ch, int start, int length)."
	
	stack last characters: aString! !

!MAXMLParser methodsFor: 'private' stamp: 'jvds 1/30/2010 17:10'!
descriptionCollectionOfObjects

	^MAToManyRelationDescription new
		classes: (Array with: Object);
		yourself! !

!MAXMLParser methodsFor: 'content' stamp: 'jvds 1/30/2010 16:23'!
endElement: elementName

	stack last endElement: elementName! !

!MAXMLParser methodsFor: 'accessing' stamp: 'jvds 1/30/2010 22:24'!
idDictionary
	^idDictionary! !

!MAXMLParser methodsFor: 'initialize-release' stamp: 'jvds 1/31/2010 10:54'!
initialize

	super initialize.
	stack := OrderedCollection new.
	idDictionary := Dictionary new! !

!MAXMLParser methodsFor: 'accessing-stack' stamp: 'jvds 1/30/2010 17:06'!
popAndProcess: anObject using: aDescription

	stack removeLast.
	stack isEmpty
		ifTrue: [ result := anObject ]
		ifFalse: [ stack last addChild: anObject using: aDescription ]! !

!MAXMLParser methodsFor: 'accessing-stack' stamp: 'jvds 1/30/2010 17:12'!
push: aUnitParser

	stack add: aUnitParser! !

!MAXMLParser methodsFor: 'accessing' stamp: 'jvds 1/30/2010 17:05'!
result
	^result! !

!MAXMLParser methodsFor: 'content' stamp: 'jvds 1/31/2010 10:57'!
startElement: elementName attributeList: attributeList

	| class object |
	
	stack notEmpty
		ifTrue: [ ^stack last startElement: elementName attributeList: attributeList ].
		
	class := Smalltalk at: elementName asSymbol ifAbsent: [ nil ].
	object := class new.
	attributeList at: 'id' ifPresent: [ :id | idDictionary at: id put: object ].
	
	(class inheritsFrom: Collection)
		ifTrue: [
			self push: (MAXMLCollectionParser for: self with: object using: self descriptionCollectionOfObjects )]
		ifFalse: [
			self push: (MAXMLContainerParser for: self with: object using: object description)]! !

MAStringReader subclass: #MAXMLStringReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLStringReader methodsFor: 'visiting-description' stamp: 'jvds 2/5/2010 11:54'!
getOptionFor: aDescription from: aString

	aDescription reference kind = Class
		ifTrue: [ ^Smalltalk at: aString asSymbol ].

	aDescription options do: [ :option |
		aString = (aDescription labelForOption: option)
			ifTrue: [ ^option ]].
		
	^aDescription reference fromString: aString! !

!MAXMLStringReader methodsFor: 'visiting-description' stamp: 'jvds 2/2/2010 23:00'!
visitDateDescription: aDescription

	| year month day |
	
	year := stream upTo: $-.
	month := stream upTo: $-.
	day := stream upToEnd.
	self object: ([ Date newDay: day asNumber month: month asNumber year: year asNumber ]
			on: Error do: [ :err | MAReadError signal: err messageText ])! !

!MAXMLStringReader methodsFor: 'visiting-description' stamp: 'jvds 2/5/2010 11:57'!
visitMultipleOptionDescription: aDescription

	self object: (Array streamContents: [ :output |
		[ self stream atEnd ] whileFalse: [
			output nextPut: (self getOptionFor: aDescription from: (self stream upTo: $,)).
			self stream peek = Character space
				ifTrue: [ self stream next ]]])! !

!MAXMLStringReader methodsFor: 'visiting-description' stamp: 'jvds 2/5/2010 11:57'!
visitSingleOptionDescription: aDescription

	self object: (self getOptionFor: aDescription from: self contents)! !

!MAContainer class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/1/2010 22:33'!
defaultXMLUnitParser
	^MAXMLContainerParser! !

!MAContainer methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/27/2010 13:42'!
atXMLTag: name ifAbsent: aBlock
	^self detect: [ :each | each xmlTag = name ] ifNone: aBlock! !

!MAToOneRelationDescription class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/1/2010 22:35'!
defaultXMLUnitParser
	^MAXMLToOneRelationParser! !

!MADescription class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/27/2010 15:42'!
defaultXMLStringReader
	^MAXMLStringReader! !

!MADescription class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/1/2010 22:32'!
defaultXMLUnitParser
	self subclassResponsibility! !

!MADescription class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/27/2010 10:46'!
defaultXMLWriter
	^MAXMLWriter! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/4/2010 12:53'!
defaultXMLTag

	| tag |
	
	(self accessor respondsTo: #readSelector)
		ifTrue: [ ^self accessor readSelector greaseString ].
		
	tag := self label select: [ :char | char isAlphaNumeric ].
	tag size > 0
		ifTrue: [ tag at: 1 put: tag first asLowercase ].
	^tag! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/27/2010 15:49'!
fromXMLString: aString
	"Answer a string being formatted from ==anObject== using ==aFormatter==."
	^self fromString: aString reader: self xmlStringReader! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/20/2010 22:42'!
toXML: anObject
	"Answer ==anObject== as XML."

	^ self toXML: anObject writer: self xmlWriter! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/27/2010 12:13'!
toXML: anObject writer: aXMLWriter
	"Answer a string being formatted from ==anObject== using ==aFormatter==."

	^(aXMLWriter write: anObject description: self) contents! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/27/2010 15:43'!
xmlStringReader
	"Answer a Visitor that can be used to convert a xml string."

	^ self propertyAt: #xmlStringReader ifAbsent: [ self class defaultXMLStringReader ]! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/20/2010 23:36'!
xmlTag
	^self propertyAt: #xmlTag ifAbsent: [ self defaultXMLTag]! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/1/2010 22:32'!
xmlUnitParser
	"Answer a subclass of XMLUnitParser that can parse XML elements described by the receiver."

	^ self propertyAt: #xmlUnitParser ifAbsent: [ self class defaultXMLUnitParser]! !

!MADescription methodsFor: '*magritte-xmlsupport' stamp: 'jvds 1/20/2010 22:31'!
xmlWriter
	"Answer a Visitor that can be used to convert the model described by the receiver to xml."

	^ self propertyAt: #xmlWriter ifAbsent: [ self class defaultXMLWriter ]! !

TestCase subclass: #MAXMLTestBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport-Tests'!

MAXMLTestBase subclass: #MAXMLDescriptionParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport-Tests'!

!MAXMLDescriptionParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 22:24'!
testStringDescription

	| address xml parsedAddress |
	
	address := MAXMLTestAddress new
		street: '';
		city: nil;
		yourself.

	xml := address description toXML: address.

	parsedAddress := MAXMLParser parse: xml readStream.
	
	self assert: (parsedAddress street = '').
	self assert: (parsedAddress city isNil)! !

!MAXMLDescriptionParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 23:12'!
testTokenDescription

	| person xml parsedPerson |
	
	person := MAXMLTestPerson new
		name: 'Kees';
		hobbies: #( 'Tennis' 'Chess' 'Programming');
		yourself.
		
	xml := person description toXML: person.

	parsedPerson := MAXMLParser parse: xml readStream.
	
	self assert: (parsedPerson hobbies isCollection).
	self assert: (person hobbies = parsedPerson hobbies)! !

MAXMLTestBase subclass: #MAXMLParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport-Tests'!

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/2/2010 23:07'!
testInvalidDateError
	"Try to parse an invalid date. This should raise a MAReadError."

	| xml |
	
	xml := '<MAXMLTestPerson>
		<name>Bill</name>
		<birthDate>1966-99-99</birthDate>
	</MAXMLTestPerson>'.
	
	self should: [ MAXMLParser parse: xml readStream ] raise: MAReadError.! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 23:13'!
testInvalidElement

	| xml person |
	
	xml := '<MAXMLTestPerson>
		<name>Bill Gates</name>
		<birthDate>1966-10-20</birthDate>
	</MAXMLTestPerson>'.
	
	person := MAXMLParser parse: xml readStream.
	
	self assert: (person isKindOf: MAXMLTestPerson).
	self assert: (person name = 'Bill Gates').
	self assert: (person birthDate = (Date newDay: 20 month: 10 year: 1966))! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 18:00'!
testInvalidXML
	"Invalid XML. Shouldn't the sax parser throw an exception?"

	| xml person |
	
	xml := '<MAXMLTestPerson>
		<name>Bill</error>
		<birthDate>1966-10-20</birthDate>
	</Error>'.
	
	person := MAXMLParser parse: xml readStream.
	
	self assert: (person isKindOf: MAXMLTestPerson).
	self assert: (person name = 'Bill').
	self assert: (person birthDate = (Date newDay: 20 month: 10 year: 1966))! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 21:12'!
testPersonWithAddress

	| person |
	
	person := MAXMLParser parse: self personWithAddressXML readStream.
	
	self assert: (person isKindOf: MAXMLTestPerson).
	self assert: (person address isKindOf: MAXMLTestAddress).
	self assert: (person address city = 'Amsterdam')! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 18:00'!
testPersonWithFriends

	| person |
	
	person := MAXMLParser parse: self personWithFriendsXML readStream.
	
	self assert: (person isKindOf: MAXMLTestPerson).
	self assert: (person friends isKindOf: OrderedCollection).! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 18:00'!
testPersonWithFriendsCycle

	| person xml parsedPerson set |
	
	person := self personWithFriendsCycle.
	
	xml := person description toXML: person.

	parsedPerson := MAXMLParser parse: xml readStream.
	
	self assert: (person name = parsedPerson name).
	self assert: (person friends last name = parsedPerson friends last name).
	
	set := Set new
		addAll: parsedPerson friends;
		addAll: parsedPerson friends first friends;
		yourself.
	self assert: (3 = set size).
	
! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 18:00'!
testReadSimple

	| xml person |
	
	xml := '<MAXMLTestPerson><name>Bill Gates</name><birthDate>1966-10-20</birthDate></MAXMLTestPerson>'.
	
	person := MAXMLParser parse: xml readStream.
	
	self assert: (person isKindOf: MAXMLTestPerson).
	self assert: (person name = 'Bill Gates').
	self assert: (person birthDate = (Date newDay: 20 month: 10 year: 1966))! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 18:00'!
testUnknownContainer

	| xml person |
	
	xml := '<MAXMLTestPerson>
		<name>Bill Gates</name>
		<address>
			<UnknownAddress>
				<city>Amsterdam</city>
				<street>Mainstreet</street>
			</UnknownAddress>
		</address>
		<birthDate>1966-10-20</birthDate>
	</MAXMLTestPerson>'.
	
	person := MAXMLParser parse: xml readStream.
	
	self assert: (person isKindOf: MAXMLTestPerson).
	self assert: (person name = 'Bill Gates').
	self assert: (person address isNil).
	self assert: (person birthDate = (Date newDay: 20 month: 10 year: 1966))! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 18:00'!
testUnknownElement

	| xml person |
	
	xml := '<MAXMLTestPerson>
		<name>Bill Gates</name>
		<unknownElement>12345</unknownElement>
		<address>
			<MAXMLTestAddress>
				<city>Amsterdam</city>
				<unknownElement2><sub/></unknownElement2>
				<street>Mainstreet</street>
			</MAXMLTestAddress>
		</address>
		<birthDate>1966-10-20</birthDate>
	</MAXMLTestPerson>'.
	
	person := MAXMLParser parse: xml readStream.
	
	self assert: (person isKindOf: MAXMLTestPerson).
	self assert: (person name = 'Bill Gates').
	self assert: (person address street = 'Mainstreet').
	self assert: (person birthDate = (Date newDay: 20 month: 10 year: 1966))! !

!MAXMLParserTest methodsFor: 'testing' stamp: 'jvds 2/2/2010 22:54'!
testValidationError
	"Leave out the required name element. This should raise a MAValidationError."

	| xml |
	
	xml := '<MAXMLTestPerson>
		<birthDate>1966-10-20</birthDate>
	</MAXMLTestPerson>'.
	
	self should: [ MAXMLParser parse: xml readStream ] raise: MAValidationError.! !

!MAXMLTestBase methodsFor: 'accessing' stamp: 'jvds 1/30/2010 21:14'!
personCollection

	| bill john carl |
	
	bill := MAXMLTestPerson new
		name: 'Bill';
		yourself.
	john := MAXMLTestPerson new
		name: 'John';
		yourself.
	carl := MAXMLTestPerson new
		name: 'Carl';
		yourself.
	^OrderedCollection with: bill with: john with: carl! !

!MAXMLTestBase methodsFor: 'accessing' stamp: 'jvds 1/30/2010 20:33'!
personWithAddressXML

	^'<MAXMLTestPerson>
		<name>Bill Gates</name>
		<address>
			<MAXMLTestAddress>
				<city>Amsterdam</city>
				<street>Mainstreet</street>
			</MAXMLTestAddress>
		</address>
		<birthDate>1966-10-20</birthDate>
	</MAXMLTestPerson>'! !

!MAXMLTestBase methodsFor: 'accessing' stamp: 'jvds 1/27/2010 17:52'!
personWithFriends

	| bill john carl |
	
	bill := MAXMLTestPerson new
		name: 'Bill';
		yourself.
	john := MAXMLTestPerson new
		name: 'John';
		yourself.
	carl := MAXMLTestPerson new
		name: 'Carl';
		friends: (OrderedCollection with: bill with: john);
		yourself.
	^carl! !

!MAXMLTestBase methodsFor: 'accessing' stamp: 'jvds 1/30/2010 20:35'!
personWithFriendsCycle

	| bill john carl |
	
	bill := MAXMLTestPerson new
		name: 'Bill';
		yourself.
	john := MAXMLTestPerson new
		name: 'John';
		yourself.
	carl := MAXMLTestPerson new
		name: 'Carl';
		friends: (OrderedCollection with: bill with: john);
		yourself.
		
	bill friends: (OrderedCollection with: john with: carl).
	john friends: (OrderedCollection with: bill with: carl).
	
	^carl! !

!MAXMLTestBase methodsFor: 'accessing' stamp: 'jvds 2/1/2010 23:08'!
personWithFriendsXML

	^'<MAXMLTestPerson id="1"><name>Carl</name><friends><OrderedCollection><MAXMLTestPerson id="2"><name>Bill</name></MAXMLTestPerson><MAXMLTestPerson id="3"><name>John</name></MAXMLTestPerson></OrderedCollection></friends></MAXMLTestPerson>' ! !

MAXMLTestBase subclass: #MAXMLWriterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport-Tests'!

!MAXMLWriterTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 23:05'!
testPersonWithAddress

	| person xmlString xmlRoot |
	
	person := MAXMLTestPerson new.
	person 
		name: 'Bill Gates';
		birthDate: (Date newDay: 20 month: 10 year: 1966);
		address: (MAXMLTestAddress new
			street: 'Mainstreet';
			city: 'Amsterdam';
			yourself ).
		
	xmlString := person description toXML: person.
	xmlRoot := (XMLDOMParser parseDocumentFrom: xmlString readStream) root.
	
	self assert: (xmlRoot name = #MAXMLTestPerson).
	self assert: (xmlRoot attributeAt: 'id') notNil.
	self assert: ((((xmlRoot firstTagNamed: #address) firstTagNamed: #MAXMLTestAddress) contentStringAt: #street) = 'Mainstreet')
	
	
		! !

!MAXMLWriterTest methodsFor: 'testing' stamp: 'jvds 1/27/2010 17:46'!
testPersonWithFriends

	| person xml |
	
	person := self personWithFriends.
		
	xml := person description toXML: person.
	
	self assert: (self personWithFriendsXML = xml)
		! !

!MAXMLWriterTest methodsFor: 'testing' stamp: 'jvds 2/1/2010 23:11'!
testPersonWithFriendsCycle

	| person xml |
	
	person := self personWithFriendsCycle.
		
	xml := person description toXML: person.

	self assert: ('<MAXMLTestPerson id="1"><name>Carl</name><friends><OrderedCollection><MAXMLTestPerson id="2"><name>Bill</name><friends><OrderedCollection><MAXMLTestPerson id="3"><name>John</name><friends><OrderedCollection><MAXMLTestPerson ref="2"/> <MAXMLTestPerson ref="1"/> </OrderedCollection></friends></MAXMLTestPerson><MAXMLTestPerson ref="1"/> </OrderedCollection></friends></MAXMLTestPerson><MAXMLTestPerson ref="3"/> </OrderedCollection></friends></MAXMLTestPerson>' = xml)
		! !

!MAXMLWriterTest methodsFor: 'testing' stamp: 'jvds 1/30/2010 22:13'!
testSimpleObject

	| person xml |
	
	person := MAXMLTestPerson new.
	person 
		name: 'Bill Gates';
		birthDate: (Date newDay: 20 month: 10 year: 1966).
		
	xml := person description toXML: person.
	
	self assert: ('<MAXMLTestPerson id="1"><name>Bill Gates</name><birthDate>1966-10-20</birthDate></MAXMLTestPerson>' = xml)
		! !

!MAXMLWriterTest methodsFor: 'testing' stamp: 'jvds 1/30/2010 22:13'!
testWithMarkup

	| person xml |
	
	person := MAXMLTestPerson new.
	person 
		name: 'Bill <b>Gates</b>'.
		
	xml := person description toXML: person.
	
	self assert: ('<MAXMLTestPerson id="1"><name>Bill &lt;b&gt;Gates&lt;/b&gt;</name></MAXMLTestPerson>' = xml)
		! !

!MAStringDescription class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/1/2010 22:34'!
defaultXMLUnitParser
	^MAXMLStringParser! !

!MAElementDescription class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/1/2010 22:34'!
defaultXMLUnitParser
	^MAXMLElementParser! !

Object subclass: #MAXMLTestAddress
	instanceVariableNames: 'street city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport-Tests'!

!MAXMLTestAddress class methodsFor: 'accessing-description' stamp: 'jvds 1/28/2010 15:43'!
descriptionCity

	^MAStringDescription new
		accessor: #city;
		priority: 200;
		yourself! !

!MAXMLTestAddress class methodsFor: 'accessing-description' stamp: 'jvds 1/28/2010 15:43'!
descriptionStreet

	^MAStringDescription new
		accessor: #street;
		priority: 100;
		yourself! !

!MAXMLTestAddress methodsFor: 'accessing' stamp: 'jvds 1/21/2010 12:53'!
city
	^ city! !

!MAXMLTestAddress methodsFor: 'accessing' stamp: 'jvds 1/21/2010 12:53'!
city: anObject
	city := anObject! !

!MAXMLTestAddress methodsFor: 'accessing' stamp: 'jvds 1/21/2010 12:53'!
street
	^ street! !

!MAXMLTestAddress methodsFor: 'accessing' stamp: 'jvds 1/21/2010 12:53'!
street: anObject
	street := anObject! !

Object subclass: #MAXMLTestPerson
	instanceVariableNames: 'name address birthDate friends hobbies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport-Tests'!

!MAXMLTestPerson class methodsFor: 'accessing-description' stamp: 'jvds 1/27/2010 10:36'!
descriptionAddress

	^ MAToOneRelationDescription new
		classes: (Array with: MAXMLTestAddress);
		accessor: #address;
		label: 'Address';
		priority: 200;
		yourself! !

!MAXMLTestPerson class methodsFor: 'accessing-description' stamp: 'jvds 1/21/2010 13:43'!
descriptionBirthDate

	^ MADateDescription new
		accessor: #birthDate;
		label: 'Date of Birth';
		priority: 300;
		yourself! !

!MAXMLTestPerson class methodsFor: 'accessing-description' stamp: 'jvds 2/1/2010 23:16'!
descriptionFriends

	^ MAToManyRelationDescription new
		classes: (Array with: self);
		accessor: #friends;
		label: 'Friends';
		priority: 400;
		yourself! !

!MAXMLTestPerson class methodsFor: 'accessing-description' stamp: 'jvds 2/1/2010 18:25'!
descriptionHobbies

	^ MATokenDescription new
		parameterName: 'hobbies';
		accessor: #hobbies;
		label: 'Hobbies';
		priority: 500;
		yourself! !

!MAXMLTestPerson class methodsFor: 'accessing-description' stamp: 'jvds 2/1/2010 18:25'!
descriptionName

	^MAStringDescription new
		accessor: #name;
		beRequired;
		label: 'Name';
		priority: 100;
		yourself! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/20/2010 22:45'!
address
	^ address! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/20/2010 22:45'!
address: anObject
	address := anObject! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/21/2010 13:43'!
birthDate
	^ birthDate! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/21/2010 13:43'!
birthDate: anObject
	birthDate := anObject! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/27/2010 17:00'!
friends
	^friends! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/27/2010 17:01'!
friends: aCollection
	friends := aCollection! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 2/1/2010 18:23'!
hobbies
	^ hobbies! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 2/1/2010 18:23'!
hobbies: anObject
	hobbies := anObject! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/20/2010 22:45'!
name
	^ name! !

!MAXMLTestPerson methodsFor: 'accessing' stamp: 'jvds 1/20/2010 22:45'!
name: anObject
	name := anObject! !

Object subclass: #MAXMLUnitParser
	instanceVariableNames: 'mainParser description object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLUnitParser commentStamp: 'jvds 2/1/2010 23:22' prior: 0!
A MAXMLUnitParser is responsible for parsing a sub-tree of an xml document.

Instance Variables
	description:		<MADescription>
	mainParser:		<MAXMLParser>
	object:		<Object>

description
	- the description that describes this part of the xml tree

mainParser
	- the main SAX parser that maintains a stack of unit parsers

object
	- after the endElement method is executed this should contain the parsed object
!

MAXMLUnitParser subclass: #MAXMLCollectionParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLCollectionParser commentStamp: 'jvds 2/1/2010 23:23' prior: 0!
A MAXMLCollectionParser is a UnitParser that can handle collections of Magritte objects.!

!MAXMLCollectionParser methodsFor: 'updating' stamp: 'jvds 2/9/2010 15:58'!
addChild: childObject using: aDescription
	"Add ==childObject== to the receivers (collection) object."

	childObject notNil
		ifTrue: [ object add: childObject ]! !

!MAXMLCollectionParser methodsFor: 'content' stamp: 'jvds 2/9/2010 16:01'!
characters: aString
	"Ignore"! !

!MAXMLCollectionParser methodsFor: 'content' stamp: 'jvds 1/31/2010 15:27'!
startElement: elementName attributeList: attributeList

	| refDescription refObject |

	refObject := self resolveToObject: elementName attributeList: attributeList
			ifAbsent: [ self handleUnknownElement: elementName attributeList: attributeList ].
	refDescription := refObject description.
	self pushContainerParserWith: refObject using: refDescription.
! !

MAXMLUnitParser subclass: #MAXMLContainerParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLContainerParser commentStamp: 'jvds 2/1/2010 23:24' prior: 0!
A MAXMLContainerParser is a UnitParser that can handle Magritte objects. This means objects that have a MAContainerDescription as their description.!

!MAXMLContainerParser methodsFor: 'content' stamp: 'jvds 2/2/2010 21:12'!
characters: aString
	"Ignore"! !

!MAXMLContainerParser methodsFor: 'content' stamp: 'jvds 2/2/2010 22:47'!
endElement: elementName
	
	description validate: object.
	super endElement: elementName ! !

!MAXMLContainerParser methodsFor: 'content' stamp: 'jvds 1/30/2010 21:00'!
startElement: elementName attributeList: attributeList

	| elemDescription |
	
	elemDescription := description 
			atXMLTag: elementName 
			ifAbsent: [ ^self handleUnknownElement: elementName attributeList: attributeList ].
			
	self pushElementParserUsing: elemDescription! !

MAXMLUnitParser subclass: #MAXMLDummyParser
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLDummyParser commentStamp: 'jvds 2/1/2010 23:24' prior: 0!
A MAXMLDummyParser is used to ignore a xml sub-tree for which no description can be found. !

!MAXMLDummyParser methodsFor: 'content' stamp: 'jvds 1/30/2010 20:48'!
characters: aString
	"Ignore"! !

!MAXMLDummyParser methodsFor: 'content' stamp: 'jvds 1/30/2010 20:51'!
endElement: elementName
	
	level := level - 1.
	level = 0
		ifTrue: [ super endElement: elementName ]! !

!MAXMLDummyParser methodsFor: 'initialize-release' stamp: 'jvds 1/30/2010 20:55'!
initialize

	super initialize.
	level := 1! !

!MAXMLDummyParser methodsFor: 'content' stamp: 'jvds 1/30/2010 20:49'!
startElement: elementName attributeList: attributeList

	level := level + 1! !

MAXMLUnitParser subclass: #MAXMLElementParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLElementParser commentStamp: 'jvds 2/1/2010 23:25' prior: 0!
A MAXMLElementParser is a UnitParser that can handle the elements of Magritte objects. !

!MAXMLElementParser methodsFor: 'content' stamp: 'jvds 2/9/2010 16:03'!
characters: aString
	"Use the receivers description to convert the xml character data in ==aString==
	to an element value."
	
	object := description fromXMLString: aString! !

!MAXMLElementParser methodsFor: 'content' stamp: 'jvds 1/30/2010 16:48'!
startElement: elementName attributeList: attributeList

	self error: 'Not Expected :-('
			
			
				
		! !

MAXMLElementParser subclass: #MAXMLStringParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLStringParser methodsFor: 'initialize-release' stamp: 'jvds 2/9/2010 16:05'!
initializeFor: aMainParser with: anObjectOrNil using: aDescription
	"This method is overridden to set the default value to an empty String 
	instead of nil. We need this because for empty elements the
	characters: method is never called by the SAX parser."

	| value |
	value := anObjectOrNil isNil
		ifTrue: [ '' ]
		ifFalse: [ anObjectOrNil ].
	super initializeFor: aMainParser with: value using: aDescription ! !

MAXMLElementParser subclass: #MAXMLToManyRelationParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLToManyRelationParser methodsFor: 'updating' stamp: 'jvds 2/9/2010 15:57'!
addChild: childObject using: aDescription

	object notNil
		ifTrue: [ self error: 'Invalid state' ].

	object := childObject.! !

!MAXMLToManyRelationParser methodsFor: 'content' stamp: 'jvds 1/31/2010 15:27'!
startElement: elementName attributeList: attributeList

	| refColl |

	refColl :=  self resolveToObject: elementName attributeList: attributeList
			ifAbsent: [ self handleUnknownElement: elementName attributeList: attributeList ].
	refColl isCollection
		ifFalse: [ self error: 'Collection expected' ].
	
	self pushCollectionParserWith: refColl using: description! !

MAXMLElementParser subclass: #MAXMLToOneRelationParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLToOneRelationParser methodsFor: 'updating' stamp: 'jvds 2/9/2010 15:57'!
addChild: childObject using: aDescription

	object notNil
		ifTrue: [ self error: 'Invalid state' ].

	object := childObject.! !

!MAXMLToOneRelationParser methodsFor: 'content' stamp: 'jvds 2/1/2010 21:11'!
startElement: elementName attributeList: attributeList

	| refDescription refObject |

	refObject := self resolveToObject: elementName attributeList: attributeList
			ifAbsent: [ ^self handleUnknownElement: elementName attributeList: attributeList ].
	refDescription := refObject description.
	self pushContainerParserWith: refObject using: refDescription.
! !

!MAXMLUnitParser class methodsFor: 'instance creation' stamp: 'jvds 1/30/2010 16:51'!
for: aMainParser with: anObject using: aDescription

	^self new initializeFor: aMainParser with: anObject using: aDescription! !

!MAXMLUnitParser methodsFor: 'updating' stamp: 'jvds 2/9/2010 15:58'!
addChild: childObject using: aDescription
	"Update the receivers object with ==childObject== using ==aDescription==."

	aDescription notNil
		ifTrue: [ object write: childObject using: aDescription ]! !

!MAXMLUnitParser methodsFor: 'content' stamp: 'jvds 1/30/2010 15:21'!
characters: aString
	"This call corresponds to the Java SAX call
	characters(char[] ch, int start, int length)."
	
	self subclassResponsibility! !

!MAXMLUnitParser methodsFor: 'content' stamp: 'jvds 1/30/2010 16:41'!
endElement: elementName
	
	mainParser popAndProcess: object using: description
	
	! !

!MAXMLUnitParser methodsFor: 'internal' stamp: 'jvds 1/31/2010 15:25'!
handleUnknownElement: elementName attributeList: attributeList
	"==elementName== is an unregocnized element. Use a dummy parser to ignore the
	element and all its children."

	^self pushDummyParser! !

!MAXMLUnitParser methodsFor: 'initialize-release' stamp: 'jvds 1/30/2010 16:50'!
initializeFor: aMainParser with: anObjectOrNil using: aDescription

	mainParser := aMainParser.
	object := anObjectOrNil.
	description := aDescription.! !

!MAXMLUnitParser methodsFor: 'internal' stamp: 'jvds 2/1/2010 22:44'!
pushCollectionParserWith: aCollection using: aDescription
	mainParser push: (MAXMLCollectionParser for: mainParser with: aCollection using: aDescription)! !

!MAXMLUnitParser methodsFor: 'internal' stamp: 'jvds 2/1/2010 22:44'!
pushContainerParserWith: anObject using: aDescription
	mainParser push: (MAXMLContainerParser for: mainParser with: anObject using: aDescription)! !

!MAXMLUnitParser methodsFor: 'internal' stamp: 'jvds 2/1/2010 22:37'!
pushDummyParser
	mainParser push: (MAXMLDummyParser for: mainParser with: nil using: nil)! !

!MAXMLUnitParser methodsFor: 'internal' stamp: 'jvds 2/1/2010 22:37'!
pushElementParserUsing: aDescription
	mainParser push: (aDescription xmlUnitParser for: mainParser with: nil using: aDescription)! !

!MAXMLUnitParser methodsFor: 'internal' stamp: 'jvds 2/9/2010 15:56'!
resolveToObject: elementName attributeList: attributeList ifAbsent: aBlock
	"Create and answer an object that is represented by ==elementName== and ==attributeList==.
	If ==attributeList== contains a 'ref' attribute this element refers to an already parsed
	object."

	| newObject |
	
	attributeList at: 'ref' ifPresent: [ :ref | ^mainParser idDictionary at: ref ifAbsent: aBlock ].

	newObject := (Smalltalk at: elementName asSymbol ifAbsent: [ ^aBlock value ]) new.
	attributeList at: 'id' ifPresent: [ :id | mainParser idDictionary at: id put: newObject ].
	^newObject! !

!MAXMLUnitParser methodsFor: 'content' stamp: 'jvds 1/30/2010 16:45'!
startElement: elementName attributeList: attributeList

	self subclassResponsibility! !

MAWriter subclass: #MAXMLWriter
	instanceVariableNames: 'xmlOut objectDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLSupport'!

!MAXMLWriter class methodsFor: 'instance creation' stamp: 'jvds 2/1/2010 21:18'!
write: anObject description: aDescription to: aXMLWriter with: anObjectDict
	^self new write: anObject description: aDescription to: aXMLWriter with: anObjectDict! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 1/20/2010 23:01'!
defaultWriteStream
	^WriteStream on: String new! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 1/27/2010 12:07'!
defaultXMLWriter
	^XMLWriter on: self defaultWriteStream! !

!MAXMLWriter methodsFor: 'accessing' stamp: 'jvds 1/30/2010 21:36'!
objectDictionary
	^objectDictionary! !

!MAXMLWriter methodsFor: 'accessing' stamp: 'jvds 1/30/2010 21:37'!
objectDictionary: aDictionary
	objectDictionary := aDictionary! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 2/4/2010 17:03'!
visitContainer: aDescription

	| tag id value |
	
	tag := object class name greaseString.
	id := objectDictionary at: object ifAbsent: [ nil ].
	
	id isNil
		ifTrue: [
			id := objectDictionary size + 1.
			objectDictionary at: object put: id.
			self xmlStartTag: tag withAttr: 'id' -> id printString.
			aDescription do: [ :each | each isReadonly 
				ifFalse: [
					value := self object readUsing: each.
					value notNil
						ifTrue: [ each xmlWriter write: value description: each to: xmlOut with: objectDictionary ]]].
			self xmlEndTag: tag ]
		ifFalse: [
			self xmlTag: tag withAttr: 'ref' -> id printString ]! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 2/2/2010 22:59'!
visitDateDescription: aDescription

	self object isNil
		ifTrue: [ ^super visitDateDescription: aDescription ].
		
	self xmlTag: aDescription xmlTag with: object yyyymmdd
	! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 1/21/2010 13:51'!
visitElementDescription: aDescription 
	self xmlTag: aDescription xmlTag with: (aDescription toString: object)! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 2/4/2010 14:42'!
visitMemoDescription: aDescription
	self xmlTag: aDescription xmlTag withCData: (aDescription toString: object)! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 2/9/2010 19:42'!
visitMultipleOptionDescription: aDescription

	aDescription reference kind = Class
		ifTrue: [
			| out |
			out := WriteStream on: String new.
			self object 
				do: [ :each | out nextPutAll: each name greaseString ]
				separatedBy: [ out nextPutAll: ', '].
			self xmlTag: aDescription xmlTag with: out contents ]
		ifFalse: [
			super visitMultipleOptionDescription: aDescription ]! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 2/4/2010 16:13'!
visitSingleOptionDescription: aDescription
	"If the option value is a class than just output the class name instead of the label"
	
	aDescription reference kind = Class
		ifTrue: [ self xmlTag: aDescription xmlTag with: self object name greaseString ]
		ifFalse: [ super visitSingleOptionDescription: aDescription ]! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 1/30/2010 21:38'!
visitToManyRelationDescription: aDescription
	| tag collTag |
	tag := aDescription xmlTag.
	tag isNil
		ifTrue: [ ^self ].
	collTag := self object class name.
		
	self xmlStartTag: tag.
	self xmlStartTag: collTag.
	self object do: [ :each | each description xmlWriter write: each description: each description to: xmlOut with: objectDictionary ].
	self xmlEndTag: collTag.
	self xmlEndTag: tag! !

!MAXMLWriter methodsFor: 'visiting-description' stamp: 'jvds 1/30/2010 21:39'!
visitToOneRelationDescription: aDescription
	| tag |
	tag := aDescription xmlTag.
	tag isNil
		ifTrue: [ ^self ].
		
	self xmlStartTag: tag.
	object description xmlWriter write: object description: object description to: xmlOut with: objectDictionary.			
	self xmlEndTag: tag! !

!MAXMLWriter methodsFor: 'visiting' stamp: 'jvds 1/27/2010 12:14'!
write: anObject description: aDescription
	^ self write: anObject description: aDescription to: self defaultXMLWriter! !

!MAXMLWriter methodsFor: 'visiting' stamp: 'jvds 2/1/2010 21:24'!
write: anObject description: aDescription to: aXMLWriter
	self write: anObject description: aDescription to: aXMLWriter with: (IdentityDictionary new).
	^self contents! !

!MAXMLWriter methodsFor: 'visiting' stamp: 'jvds 2/1/2010 21:22'!
write: anObject description: aDescription to: aXMLWriter with: anObjectDictionary

	self
		object: anObject;
		xmlOut: aXMLWriter;
		objectDictionary: anObjectDictionary;
		visit: aDescription.! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 1/21/2010 14:05'!
xmlEndTag: tagName
	"Write </tagName>"
	
	xmlOut
		endTag: tagName! !

!MAXMLWriter methodsFor: 'accessing' stamp: 'jvds 1/20/2010 22:57'!
xmlOut
	^xmlOut! !

!MAXMLWriter methodsFor: 'accessing' stamp: 'jvds 1/20/2010 22:56'!
xmlOut: aXMLWriter
	xmlOut := aXMLWriter.
	self stream: aXMLWriter stream! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 1/21/2010 14:05'!
xmlStartTag: tagName
	"Write <tagName>"
	
	xmlOut
		startTag: tagName; 
		endTag
! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 1/30/2010 21:48'!
xmlStartTag: tagName withAttr: anAttrAssoc
	"Write <tagName key='value'>"
	
	xmlOut
		startTag: tagName; 
		attribute: anAttrAssoc key value: anAttrAssoc value;
		endTag
! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 1/21/2010 14:04'!
xmlTag: tagName with: aValueString
	"Write <tagName>aValueString</tagName>"

	xmlOut
		startTag: tagName; 
		endTag;
		pcData: aValueString;
		endTag: tagName.! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 1/30/2010 22:20'!
xmlTag: tagName withAttr: anAttrAssoc
	"Write <tagName key='value'/>"

	xmlOut
		startTag: tagName; 
		attribute: anAttrAssoc key value: anAttrAssoc value;
		endEmptyTag: tagName! !

!MAXMLWriter methodsFor: 'private' stamp: 'jvds 2/4/2010 14:44'!
xmlTag: tagName withCData: aValueString
	"Write <tagName><!![CDATA[aValueString]]</tagName>"

	xmlOut
		startTag: tagName; 
		endTag;
		cdata: aValueString;
		endTag: tagName.! !

!MAToManyRelationDescription class methodsFor: '*magritte-xmlsupport' stamp: 'jvds 2/1/2010 22:34'!
defaultXMLUnitParser
	^MAXMLToManyRelationParser! !
